//Eratosthenovo síto

library erast;

//import knihoven potřebných k běhu alg
import 'dart:html';
import 'dart:math';

//init proměnných
int upperLimit = 600000000;
int erastNum;

initErast() {
  //init dom
  var output = querySelector('#outErast');
  var outputPrime = querySelector('#outPrimeErast');
  var input = querySelector('#erast');
  
  //key listener
  input.onKeyUp.listen((_) {
    if (input.value == "") {
      outputPrime.text = "";
      output.text = "Prázdné pole.";
    } else {
      //init pro stopky
      Stopwatch watch = new Stopwatch()..start();
      //vstup od uživatele
      erastNum = int.parse(input.value);
      
      //rozmězí možných hodnot
      if ((erastNum > 1) && (erastNum <= upperLimit)) {
        //generování listu pro čísla od 0 do uživatelova vstupu
        var erastList = new List<int>.generate(erastNum + 1, (int e) => e);
        //0 a 1 nejsou prvočísla
        erastList[0] = erastList[1] = 0;
        //forEach cyklus pro procházení listu
        for(int e in erastList) {
          //0 pro složené číslo
          if(e != 0) {
            //procházení od čísla 2 dle násobků
            for(int f = 2; (f * e) <= erastNum; f++) {
              //pokud se objevuje násobek, je složené číslo => 0
              erastList[f * e] = 0;
            }
          }
        }
        
        //generování listu, kde jsou jen prvočísla
        erastList = erastList.where((e) => e != 0);

        //počet prvočísel
        output.text = erastList.length.toString();
        watch.stop();
        outputPrime.text = watch.elapsed.toString() + " overall, " + watch.elapsed.inMicroseconds
                .toString();
      } else {
        
        output.text = "Zadejte, prosím, pouze čísla od 2 do 10 000 000.";
      }
    } 
  });
}


