//Fibonacciho posloupnost, rekurzivní a explicitní zadání

library fibon;

//import knihoven potřebných k běhu algoritmu
import 'dart:html';
import 'dart:math';

//init proměnné
int nums = 0;
int checked = 0;

//výchozí pro explicitní alg
double F = (1 + sqrt(5))/2;

//listener pro radioButton
void alg(Event e) {
  if((querySelector('#explicit') as RadioButtonInputElement).checked) {
    checked = 0;
  } else {
    checked = 1;
  }
}

initFibon() {
  
  //navázání na dom
  var output = querySelector('#outFibon');
  var input = querySelector('#fibon');
  querySelector('#recursive').onChange.listen(alg);
  querySelector('#explicit').onChange.listen(alg);
  var outputPrime = querySelector('#outPrimeFib');
  
  //key listener
  input.onKeyUp.listen((_) {
      if(input.value == "") {
        output.text = "Prázdné pole.";
      } else {
         //init a start pro stopky
         Stopwatch watch = new Stopwatch()..start();
         
         //input value z uživatelova vstupu
         nums = int.parse(input.value); 
         String outFib = "";
         
         
         //explicitní zadání
         if(checked == 0 ) {
           if((nums > 0) && (nums <= 1250)) {
              for(int i = 1; i <= nums; ++i) {              
                 outFib += fibon2(i).toString() + ", ";
              }
            } else {
              output.text = "Zadejte, prosím, pouze čísla od 1 do 1 250.";
            }
         }
           
          //rekurzivní zadání
          if(checked == 1) {
            if((nums > 0) && (nums <= 45)) {
              outFib += fibon(nums).toString() + ", ";
            }
          } else {
            output.text = "Zadejte, prosím, pouze čísla od 1 do 45.";
          }
         
         //vygenerování výstupů
         output.text = outFib + "...";
         watch.stop();
         outputPrime.text = watch.elapsed.toString() + " overall, " + watch.elapsed.inMicroseconds
                           .toString();
         }  
  });
}

//fce pro rekurzivní alg
int fibon(int f) => f <= 2 ? 1 : fibon(f - 2) + fibon(f - 1);

//fce pro explicitní zadání, round vrací int
int fibon2(int f) {
  double n = pow(F, f)/sqrt(5) - pow(1 - F, f)/sqrt(5);
  return n.round();
}
